#include <stdexcept>
#include "cocoadisplay.h"
#include "display.h"
#include "display_private.h"

using namespace std;

namespace Msp {
namespace Graphics {

Display::Display(const string &):
	primary_monitor(0),
	priv(new Private),
	focus_window(0)
{
	static ErrorDialog err_dlg(0);

	priv->display = create_display();
}

Display::~Display()
{
	destroy_display(priv->display);
	delete priv;
}

void Display::set_mode(const VideoMode &, bool)
{
	throw runtime_error("video mode switching not supported");
}

bool Display::process_events()
{
	Window::Event event;
	if(!get_event(priv->display, &event.cevent))
		return false;

	map<WindowHandle, Window *>::iterator i = priv->windows.find(event.cevent.any.window);
	if(i!=priv->windows.end())
		i->second->event(event);

	return true;
}

void Display::check_error()
{
}

} // namespace Graphics
} // namespace Msp
