#ifndef MSP_GRAPHICS_MONITOR_H_
#define MSP_GRAPHICS_MONITOR_H_

#include <list>
#include <string>
#include "videomode.h"

namespace Msp {
namespace Graphics {

struct Monitor
{
	struct Settings
	{
		const VideoMode *mode;
		VideoRotation rotation;
		int x, y;

		Settings();
	};

	unsigned index;
	std::string name;
	std::list<const VideoMode *> video_modes;
	Settings desktop_settings;
	Settings current_settings;
	const Monitor *next_left;
	const Monitor *next_right;

	Monitor();
};

} // namespace Graphics
} // namespace Msp

#endif
