#ifndef MSP_INPUT_KEYBOARD_H_
#define MSP_INPUT_KEYBOARD_H_

#include <sigc++/trackable.h>
#include <msp/graphics/window.h>
#include <msp/stringcodec/ustring.h>
#include "device.h"

namespace Msp {
namespace Input {

/**
Adapts key events from a window to the abstracted input framework.  Key codes
are translated to platform-independent values.  See keys.h for a list.
*/
class Keyboard: public Device, public sigc::trackable
{
public:
	sigc::signal<bool, StringCodec::unichar>::accumulated<EventAccumulator> signal_character;

private:
	Graphics::Window &window;

public:
	Keyboard(Graphics::Window &);
	virtual ~Keyboard();

	virtual std::string get_button_name(unsigned) const;
private:
	void input_event(const Graphics::Window::Event &);
};

} // namespace Input
} // namespace Msp

#endif
